VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Document"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Declare Sub CopyObject Lib "MSVBVM60.DLL" Alias "GetMemObj" (Source As Long, Target As Object)

Private varParsed As Boolean
Private WithEvents objHTMLStore As TextStore
Attribute objHTMLStore.VB_VarHelpID = -1
Private objTags As Tags
Private varTagsPointer As Long

Public Property Get Parsed() As Boolean
Parsed = varParsed
End Property

Public Property Get HTMLStore() As TextStore
Set HTMLStore = objHTMLStore
End Property

Public Property Get Tags() As Tags
Set Tags = objTags
End Property

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
Set NewEnum = objTags.NewEnum
End Property

Public Sub CleanUp()
Dispose
End Sub

Friend Sub Create()
Set objTags = New Tags
objTags.Create Nothing, Me, objHTMLStore
objTags.SetFlatMode True
varTagsPointer = ObjPtr(objTags)
End Sub

Friend Sub Dispose()
If Not objTags Is Nothing Then
  objTags.Dispose
  Set objTags = Nothing
End If
End Sub

Private Sub Class_Initialize()
#If DEBUG_MODE Then
If DEBUG_FILE > 0 Then Print #DEBUG_FILE, "Document + :: " & ObjPtr(Me)
#End If
Set objHTMLStore = New TextStore
Create
End Sub

Private Sub Class_Terminate()
Set objHTMLStore = Nothing
#If DEBUG_MODE Then
If DEBUG_FILE > 0 Then Print #DEBUG_FILE, "Document - :: " & ObjPtr(Me)
#End If
End Sub

Public Sub EnumAllTags(AllTags As Collection, Optional ByVal ByLevels As Boolean = False)
Dim objTag As Tag
Set AllTags = New Collection
If ByLevels Then
  EnumAllTags_RecurseLevel AllTags, objTags
Else
  For Each objTag In objTags
    EnumAllTags_RecurseThread AllTags, objTag
  Next objTag
End If
End Sub

Private Sub EnumAllTags_RecurseLevel(AllTags As Collection, Parent As Tags)
Dim oTag As Tag
For Each oTag In Parent
  AllTags.Add Key:=CStr(ObjPtr(oTag)), Item:=oTag
Next oTag
For Each oTag In Parent
  EnumAllTags_RecurseLevel AllTags, oTag.Childs
Next oTag
End Sub

Private Sub EnumAllTags_RecurseThread(AllTags As Collection, Parent As Tag)
Dim oTags As Tags, oTag As Tag
AllTags.Add Key:=CStr(ObjPtr(Parent)), Item:=Parent
Set oTags = Parent.Childs
For Each oTag In oTags
  EnumAllTags_RecurseThread AllTags, oTag
Next oTag
Set oTags = Nothing
End Sub

Public Function PointerTags(ByVal Pointer As Long) As Tags
If Pointer = 0 Then Exit Function
Dim obj As Tags
CopyObject Pointer, obj
Set PointerTags = obj
Set obj = Nothing
End Function

Public Function PointerTag(ByVal Pointer As Long) As Tag
If Pointer = 0 Then Exit Function
Dim obj As Tag
CopyObject Pointer, obj
Set PointerTag = obj
Set obj = Nothing
End Function

Public Sub Parse(Optional HTML As String = vbNullChar)
If HTML <> vbNullChar Then objHTMLStore.SetText HTML
Call Parse_HTML(objTags, 1, objHTMLStore.Length)
PostProcessing
varParsed = True
End Sub

Private Sub PostProcessing()

End Sub

Private Sub objHTMLStore_Change()
varParsed = False
objTags.SetFilter
objTags.Clear
End Sub

Public Function StripHTML(ByVal HTML As String, Optional ByVal StripEntities As Boolean = True, Optional ByVal StripTags As Boolean = True, Optional ByVal StripSpaces As Boolean = True, Optional ByVal StripLineFeeds As Boolean = False) As String
Dim L As Long, P0 As Long, P As Long
If StripTags And Len(HTML) > 0 Then
  Const TagPrefix As String = "<", TagPostfix As String = ">", TagRemark As String = "<!--", TagRemarkEnd As String = "-->"
  Dim TagName As String
  L = Len(HTML)
  P0 = 1
  Do Until P0 > L
    P = InStr(P0, HTML, TagRemark)
    If P = 0 Or P > L Then Exit Do
    P0 = P
    P = InStr(P0 + Len(TagRemark), HTML, TagRemarkEnd)
    If P = 0 Or P > L Then P = L + 1
    P = P + Len(TagRemarkEnd)
    If P <= L Then
      Mid$(HTML, P0, L - P + 1) = Mid$(HTML, P, L - P + 1)
    End If
    L = L - (P - P0)
  Loop
  P0 = 1
  Do Until P0 > L
    P = InStr(P0, HTML, TagPrefix)
    If P = 0 Or P > L Then Exit Do
    P0 = P
    P = InStr(P0 + Len(TagPrefix), HTML, TagPostfix)
    If P = 0 Or P > L Then P = L + 1
    P = P + Len(TagPostfix)
    If P <= L Then
      If StripLineFeeds Then
        Mid$(HTML, P0, L - P + 1) = Mid$(HTML, P, L - P + 1)
      Else
        TagName = Mid$(HTML, P0 + Len(TagPrefix), P - P0 - Len(TagPrefix) - Len(TagPostfix)) & vbSpace
        TagName = UCase$(Trim$(Left$(TagName, InStr(TagName, vbSpace) - 1)))
        Select Case TagName
          Case "P", "BR", "BR/", "HR"
            Mid$(HTML, P0, Len(vbNullChar)) = vbNullChar
            If P <= L Then Mid$(HTML, P0 + Len(vbNullChar), L - P + 1) = Mid$(HTML, P, L - P + 1)
            L = L - (P - P0) + Len(vbNullChar)
          Case Else
            Mid$(HTML, P0, L - P + 1) = Mid$(HTML, P, L - P + 1)
        End Select
      End If
    End If
    L = L - (P - P0)
  Loop
  HTML = Left$(HTML, L)
End If
If StripEntities And Len(HTML) > 0 Then
  Const EntityPrefix As String = "&", EntityPostfix As String = ";", EntityNumeric As String = "#"
  Const Entities As String = "#NBSP#160#QUOT#34#AMP#38#LT#60#GT#62#IEXCL#161#CENT#162#POUND#163#CURREN#164#YEN#165#BRVBAR#166#BRKBAR#166#SECT#167#COPY#169#REG#174#LAQUO#171#RAQUO#187#DEG#176#PLUSMN#177#SUP1#185#SUP2#178#SUP3#179#PARA#182#MIDDOT#183#FRAC12#189#FRAC14#188#FRAC34#190#IQUEST#191#TIMES#215#DIVIDE#247#ENSP#8194#EMSP#8195#THINSP#8201#NDASH#8211#MDASH#8212#LSQUO#8216#RSQUO#8217#SBQUO#8218#LDQUO#8220#RDQUO#8221#BDQUO#8222#PERMIL#8240#LSAQUO#8249#RSAQUO#8250#FNOF#402#BULL#8226#HELLIP#8230#TRADE#8482#"
  Const EntityEmpty As String = ""
  Const EntityFind  As String = ""
  Const EntitySubst As String = " "
  Dim E As String, I As Long
  L = Len(HTML)
  P0 = 1
  Do Until P0 > L
    P = InStr(P0, HTML, EntityPrefix)
    If P = 0 Or P > L Then Exit Do
    If Mid$(HTML, P + Len(EntityPrefix), Len(vbSpace)) = vbSpace Then
      P0 = P + Len(EntityPrefix)
    Else
      E = vbNullString
      P0 = P
      P = InStr(P0 + Len(EntityPrefix), HTML, EntityPostfix)
      If P = 0 Or P > L Then
        P = InStr(P0 + Len(EntityPrefix), HTML, vbSpace)
        If P = 0 Or P > L Then
          P = 0
          P0 = P0 + 1
        Else
          E = Mid$(HTML, P0 + Len(EntityPrefix), P - (P0 + Len(EntityPrefix)))
          P = P + Len(vbSpace)
        End If
      Else
        E = Mid$(HTML, P0 + Len(EntityPrefix), P - (P0 + Len(EntityPrefix)))
        P = P + Len(EntityPostfix)
      End If
      If Len(E) > 0 Then
        If Left$(E, Len(EntityNumeric)) = EntityNumeric Then
          E = ChrW$(Val(Mid$(E, 2)))
        Else
          I = InStr(Entities, "#" & UCase$(E) & "#")
          If I = 0 Then
            E = vbNullString
          Else
            I = I + Len(E) + 2
            E = ChrW$(Val(Mid$(Entities, I, InStr(I, Entities, "#") - I)))
          End If
        End If
        If InStr(EntityEmpty, E) > 0 Then E = vbNullString
        If Len(E) > 0 Then
          I = InStr(EntityFind, E)
          If I > 0 Then E = Mid$(EntitySubst, I, Len(E))
        End If
      End If
      Mid$(HTML, P0, Len(E)) = E
      If P <= L Then Mid$(HTML, P0 + Len(E), L - P + 1) = Mid$(HTML, P, L - P + 1)
      L = L - (P - P0) + Len(E)
    End If
  Loop
  HTML = Left$(HTML, L)
End If
If StripSpaces And Len(HTML) > 0 Then
  HTML = Replace$(HTML, vbCrLf, vbSpace)
  HTML = Replace$(HTML, vbCr, vbSpace)
  HTML = Replace(HTML, vbLf, vbSpace)
  HTML = Replace$(HTML, vbTab, vbSpace)
  HTML = Trim$(HTML)
  If Len(HTML) > 0 Then
    L = 0
    While Len(HTML) <> L
      L = Len(HTML)
      HTML = Replace$(HTML, vbSpace2, vbSpace)
    Wend
  End If
  If Not StripLineFeeds Then
    HTML = Replace$(HTML, vbSpace & vbNullChar, vbNullChar)
    HTML = Replace$(HTML, vbNullChar & vbSpace, vbNullChar)
    P = 1
    L = Len(HTML)
    Do While L >= P
      P0 = 0
      If Mid$(HTML, P, Len(vbNullChar)) = vbNullChar Then
        P = P + 1
        P0 = 1
      End If
      If Mid$(HTML, L - Len(vbNullChar) + 1, Len(vbNullChar)) = vbNullChar Then
        L = L - 1
        P0 = 1
      End If
      If P0 = 0 Then Exit Do
    Loop
    If L < P Then L = P - 1
    HTML = Mid$(HTML, P, L - P + 1)
    HTML = Replace$(HTML, vbNullChar, vbNewLine)
  End If
End If
StripHTML = HTML
End Function

Private Function FindPos(Text As String, Start As Long, MinPos As Long, MaxPos As Long, Optional IfNotFound As Long) As Long
Dim P As Long
P = InStr(Start, objHTMLStore.Value, Text)
If P < MinPos Or P = 0 Then P = IfNotFound
If MaxPos > 0 And P > MaxPos Then P = IfNotFound
FindPos = P
End Function

Private Function FirstPos(Text As Variant, Start As Long, MinPos As Long, MaxPos As Long, Optional IfNotFound As Long, Optional ByRef Index As Long) As Long
Dim I As Long, P As Long, P0 As Long
P0 = 0
Index = 0
For I = LBound(Text) To UBound(Text)
  P = InStr(Start, objHTMLStore.Value, Text(I))
  If P < MinPos Then P = 0
  If MaxPos > 0 And P > MaxPos Then P = 0
  If P > 0 And (P < P0 Or P0 = 0) Then
    Index = I
    P0 = P
  End If
Next I
If P0 = 0 Then P0 = IfNotFound
FirstPos = P0
End Function

Private Sub Parse_HTML(TagCollection As Tags, ByVal PosFrom As Long, ByVal PosTo As Long)
Const TagStart As String = "<", TagEnd As String = ">", TagClose As String = "/", TagDisable As String = "!", TagRemark As String = "!--", RemarkStart As String = "<!--", RemarkEnd As String = "-->", DocType As String = "!DOCTYPE"
Dim objTag As Tag, TagName As String, TagDisabled As Boolean, TagDepth As Long, S As String, P As Long, PosCurrent As Long, PosOut As Long, PosStart As Long, PosEnd As Long, ClosePosStart As Long, ClosePosEnd As Long
Dim Node As MSComctlLib.Node
PosCurrent = PosFrom
PosOut = objHTMLStore.Length + 1
Do Until PosCurrent > PosTo
  PosStart = FindPos(TagStart, PosCurrent, PosFrom, PosTo, PosOut)
  If PosStart > PosTo Then Exit Do
  If FindPos(RemarkStart, PosStart, PosFrom, PosTo) = PosStart Then
    'If remarks
    PosEnd = FindPos(RemarkEnd, PosStart, PosFrom, PosTo, PosOut)
    PosCurrent = IIf(PosEnd > PosTo, PosTo + 1, PosEnd + Len(RemarkEnd))
    Set objTag = TagCollection.Add(Name:=TagRemark, Disabled:=True)
    Parse_Tag objTag, False, PosStart, PosEnd + Len(RemarkEnd) - 1, PosStart + Len(RemarkStart), PosEnd - Len(RemarkEnd), 0, 0
    Set objTag = Nothing
  Else
    'If not remarks
    If FindPos(TagClose, PosStart, PosFrom, PosTo) = PosStart + Len(TagStart) Then
      'If close tag
      PosEnd = FindPos(TagEnd, PosStart, PosFrom, PosTo, PosOut)
      PosCurrent = IIf(PosEnd > PosTo, PosTo + 1, PosEnd + Len(TagEnd))
    Else
      'If not close tag
      PosEnd = FindPos(TagEnd, PosStart, PosFrom, PosTo, PosOut)
      P = FirstPos(Array(vbSpace, vbNewLine, vbLf, vbTab, TagClose, TagEnd), PosStart + Len(TagStart), PosStart, PosEnd, PosEnd)
      TagName = UCase$(objHTMLStore.Mid2(PosStart + Len(TagStart), P - 1))
      If TagName = DocType Then
        TagDisabled = False
      Else
        TagDisabled = (Left$(TagName, Len(TagDisable)) = TagDisable)
        If TagDisabled Then TagName = Mid$(TagName, 2)
      End If
      If FindPos(TagClose, PosEnd - Len(TagClose), PosFrom, PosTo) = PosEnd - Len(TagClose) Or TagName = DocType Then
        'If standalone tag
        Set objTag = TagCollection.Add(Name:=TagName, Disabled:=TagDisabled)
        Parse_Tag objTag, False, PosStart, PosEnd + Len(TagEnd) - 1, 0, 0, PosStart, PosEnd + Len(TagEnd) - 1
        Set objTag = Nothing
        PosCurrent = PosEnd + Len(TagEnd)
      Else
        'If open tag
        TagDepth = 0
        ClosePosStart = PosEnd + Len(TagEnd)
        Do Until ClosePosStart > PosTo
          P = FindPos(TagStart, ClosePosStart, PosFrom, PosTo, PosOut)
          If FindPos(RemarkStart, P, PosFrom, PosTo) = P Then
            'If remarks
            P = FindPos(RemarkEnd, P, PosFrom, PosTo, PosOut)
            ClosePosStart = IIf(P > PosTo, PosTo + 1, P + Len(RemarkEnd))
          Else
            'If not remarks
            ClosePosStart = P
            If FindPos(TagClose, ClosePosStart, PosFrom, PosTo) = ClosePosStart + Len(TagStart) Then
              'If close tag
              P = FindPos(TagEnd, ClosePosStart, PosFrom, PosTo, PosOut)
              ClosePosEnd = IIf(P > PosTo, PosTo + 1, P + Len(TagEnd) - 1)
              P = FirstPos(Array(vbSpace, vbNewLine, vbLf, vbTab, TagClose, TagEnd), ClosePosStart + Len(TagStart) + Len(TagClose), ClosePosStart, ClosePosEnd, ClosePosEnd)
              S = UCase$(objHTMLStore.Mid2(ClosePosStart + Len(TagStart) + Len(TagClose), P - 1))
              If TagDisabled And Left$(S, Len(TagDisable)) = TagDisable Then S = Mid$(S, 2)
              If S = TagName Then
                If TagDepth = 0 Then Exit Do
                TagDepth = TagDepth - 1
              End If
              ClosePosStart = ClosePosEnd + Len(TagEnd)
              ClosePosEnd = 0
            Else
              'If not close tag
              ClosePosEnd = FindPos(TagEnd, ClosePosStart, PosFrom, PosTo, PosOut)
              P = FirstPos(Array(vbSpace, vbNewLine, vbLf, vbTab, TagClose, TagEnd), ClosePosStart + Len(TagStart), ClosePosStart, ClosePosEnd, ClosePosEnd)
              S = UCase$(objHTMLStore.Mid2(ClosePosStart + Len(TagStart), P - 1))
              If S = TagName Then
                TagDepth = TagDepth + 1
              End If
              ClosePosStart = ClosePosEnd + Len(TagEnd)
            End If
          End If
        Loop
        If ClosePosEnd = 0 Or ClosePosEnd < ClosePosStart Then
          Set objTag = TagCollection.Add(Name:=TagName, Disabled:=TagDisabled)
          Parse_Tag objTag, False, PosStart, PosEnd + Len(TagEnd) - 1, 0, 0, PosStart, PosEnd + Len(TagEnd) - 1
          Set objTag = Nothing
          PosCurrent = PosEnd + Len(TagEnd)
        Else
          Set objTag = TagCollection.Add(Name:=TagName, Disabled:=TagDisabled)
          Parse_Tag objTag, False, PosStart, PosEnd + Len(TagEnd) - 1, PosEnd + Len(TagEnd), ClosePosStart - 1, ClosePosStart, ClosePosEnd + Len(TagEnd) - 1
          Parse_HTML objTag.Childs, PosEnd + Len(TagEnd), ClosePosStart - 1
          Set objTag = Nothing
          PosCurrent = ClosePosEnd + Len(TagEnd)
        End If
      End If
    End If
  End If
Loop
End Sub

Private Function FirstPosInList(List As String, Start As Long, LastPos As Long, Optional IfNotFound As Long) As Long
Dim P As Long
If Start = 0 Then Exit Function
P = Start
Do
  If P > LastPos Then Exit Do
  If InStr(List, objHTMLStore.Mid1(P, 1)) > 0 Then Exit Do
  P = P + 1
Loop
If P > LastPos Then P = IfNotFound
FirstPosInList = P
End Function

Private Function FirstPosNotList(List As String, Start As Long, LastPos As Long, Optional IfNotFound As Long) As Long
Dim P As Long
If Start = 0 Then Exit Function
P = Start
Do
  If P > LastPos Then Exit Do
  If InStr(List, objHTMLStore.Mid1(P, 1)) = 0 Then Exit Do
  P = P + 1
Loop
If P > LastPos Then P = IfNotFound
FirstPosNotList = P
End Function

Private Sub Parse_Tag(TagItem As Tag, ByVal CompactAttributes As Boolean, ByVal TagOpenStart As Long, ByVal TagOpenEnd As Long, ByVal TagValueStart As Long, ByVal TagValueEnd As Long, ByVal TagCloseStart As Long, ByVal TagCloseEnd As Long)
Const TagStart As String = "<", TagEnd As String = ">", TagClose As String = "/", TagDisable As String = "!", TagRemark As String = "!--", RemarkStart As String = "<!--", RemarkEnd As String = "-->", DocType As String = "!DOCTYPE", CharEqual As String = "=", CharQuotes As String = "'"""
Const Delimiters As String = vbSpace & vbNewLine & vbTab & CharEqual
Dim A As TagAttribute, S As String, I1 As Long, I2 As Long, P As Long, P0 As Long, I As Long, fValue As Boolean
TagItem.SetTagOpen (TagOpenStart > 0 And TagOpenEnd > 0)
TagItem.SetTagOpenPosStart TagOpenStart
TagItem.SetTagOpenPosEnd TagOpenEnd
TagItem.SetTagClose (TagCloseStart > 0 And TagCloseEnd > 0)
TagItem.SetTagClosePosStart TagCloseStart
TagItem.SetTagClosePosEnd TagCloseEnd
TagItem.SetTagValue (TagValueStart > 0 And TagValueEnd > 0)
TagItem.SetTagValuePosStart TagValueStart
TagItem.SetTagValuePosEnd TagValueEnd
If TagItem.Name = DocType Then
  TagItem.SetText Trim$(objHTMLStore.Mid2(TagOpenStart + Len(DocType) + 2, TagOpenEnd - 1))
ElseIf TagItem.Name = TagRemark Then
  TagItem.SetText objHTMLStore.Mid2(TagValueStart, TagValueEnd)
  Exit Sub
Else
  TagItem.SetText StripHTML(TagItem.TagValueHTML)
End If
If Not TagItem.TagOpen Then Exit Sub
I1 = TagOpenStart + Len(TagStart)
I2 = TagOpenEnd - Len(TagEnd)
If TagItem.TagOpen And TagItem.TagClose Then
  If TagItem.TagOpenPosStart = TagItem.TagClosePosStart And TagItem.TagOpenPosEnd = TagItem.TagClosePosEnd Then
    If objHTMLStore.Mid1(I2, Len(TagClose)) = TagClose Then I2 = I2 - Len(TagClose)
  End If
End If
I1 = FirstPosInList(Delimiters, I1, I2)
If I1 = 0 Then Exit Sub
P0 = I1
Set A = Nothing
S = vbNullString
fValue = False
Do
  P = FirstPosNotList(Delimiters, P0, I2)
  If P = 0 Then Exit Do
  If FindPos(CharEqual, P0, P0, P) > 0 Then
    fValue = True
    P0 = P
  Else
    P0 = P
    I = InStr(CharQuotes, objHTMLStore.Mid1(P0, 1))
    If I = 0 Then
      P = FirstPosInList(Delimiters, P0, I2, I2 + 1)
    Else
      P = FindPos(Mid$(CharQuotes, I, 1), P0 + 1, I1, I2, I2) + 1
    End If
    S = objHTMLStore.Mid2(P0, P - 1)
    P0 = P
    If fValue Then
      If Not (A Is Nothing) Then
        A.SetValue S
        A.SetStandalone False
        Set A = Nothing
      End If
      fValue = False
    Else
      If Len(S) > 0 Then
        If CompactAttributes Then
          If TagItem.Attributes.Exist(S) Then
            Set A = TagItem.Attributes(S)
          Else
            Set A = TagItem.Attributes.Add(S, , True)
          End If
        Else
          Set A = TagItem.Attributes.Add(S, , True)
        End If
      End If
    End If
  End If
Loop
Set A = Nothing
End Sub
